<?php

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin')) require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');


class plgVMPaymentEasyPay extends vmPSPlugin
{
	public static $_this = false;

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_loggable = true;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id'; 
		$this->_tableId = 'id'; 
		$varsToPush = $this->getVarsToPush();
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}

    protected function getVmPluginCreateTableSQL()
    {
		return $this->createTableSQL('Payment EasyPay Table');
    }
    
    function getTableSQLFields()
    {
		$SQLfields = array(
	    	'id' 							=> 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id' 			=> 'int(1) UNSIGNED', 
	    	'order_number'              	=> 'char(64)',
	    	'virtuemart_paymentmethod_id' 	=> 'mediumint(1) UNSIGNED',
	    	'payment_name' 					=> 'char(255) NOT NULL DEFAULT \'\' ',
	    	'payment_order_total'       	=> 'decimal(15,5) NOT NULL DEFAULT \'0.00000\' ',
	    	'payment_currency' 				=> 'char(3) ',
	    	'cost_per_transaction' 			=> 'decimal(10,2)',
	    	'cost_percent_total' 			=> 'char(10)',
	    	'tax_id' 						=> 'smallint(1)'
		);

		return $SQLfields;
    }
    
    function plgVmConfirmedOrder($cart, $order) 
    {
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id)))
		{
	    	return null;
		}
		if (!$this->selectedThisElement($method->payment_element))
		{
	    	return false;
		}
		
		$session = JFactory::getSession();
		$return_context = $session->getId();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
	    if (!class_exists('VirtueMartModelCurrency'))
	    {
	    	require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
	    }	    
		$new_status = $method->status_pending;
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = $paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total,false);
		$cnt = count($order['items']);
		if($cnt==1)	$prod = $order['items'][0]->order_item_name;
		else $prod = "Заказ № " . $order['details']['BT']->order_number;
		
		$post_variables = Array(
			'EP_MerNo'       => $method->merchant,
			'EP_OrderNo'     => $order['details']['BT']->virtuemart_order_id,
			'EP_Sum'         => $totalInPaymentCurrency,
			'EP_Expires'     => $method->expiried,
			'EP_Comment'     => substr($prod, 0, 50), //комментарий счета (до 50 симв.)
			'EP_OrderInfo'   => substr($order['details']['BT']->product_s_desc, 0, 2000),//substr('Информация о счете', 0 , 2000), //подробный ком. (до 2000 с.)
	    	'EP_Hash'        => md5 ($method->merchant . $method->web_key . $order['details']['BT']->virtuemart_order_id . $totalInPaymentCurrency),
			'EP_Success_URL' => JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id),
	    	'EP_Cancel_URL'  => JRoute::_(JURI::root().'index.php'),
			'EP_Debug'       => $method->debug,
			'EP_Encoding'	 => $method->encoding		
		);

	   	$url = 'https://ssl.easypay.by/weborder/?EP_Module=virtuemart_3';//Адрес сервера  	
	
		$this->_virtuemart_paymentmethod_id      = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['payment_name']                = $method->payment_name;
		$dbValues['order_number']                = $order['details']['BT']->order_number;
		$dbValues['virtuemart_paymentmethod_id'] = $this->_virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction']        = $method->cost_per_transaction;
		$dbValues['cost_percent_total']          = $method->cost_percent_total;
		$dbValues['payment_currency']            = $currency_code_3 ;
		$dbValues['payment_order_total']         = $totalInPaymentCurrency;
		$dbValues['tax_id']                      = $method->tax_id;
		$this->storePSPluginInternalData($dbValues);

		$html = '<form action="' . $url . '" method="post" id="easypay_form" name="easypay_form">';
		
		foreach ($post_variables as $name => $value)
		{
	    	$html.= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars($value) . '" />';
		}
		
		$html.= '</form>';

		$html.= ' <script type="text/javascript">';
		$html.= ' document.easypay_form.submit();';
		$html.= ' </script>';
		
		$cart->emptyCart ();
		return $this->processConfirmedOrderPaymentResponse(true, $cart, $order, $html, $method->payment_name, $new_status);
    } 

	//Отображение информации о заказе в админке    
	function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
	{
		if (!$this->selectedThisByMethodId($virtuemart_payment_id))
		{
	    	return null;
		}
    
		$db = JFactory::getDBO();
		$q = 'SELECT * FROM `' . $this->_tablename . '` '
			. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);
		if (!($paymentTable = $db->loadObject()))
		{
	    	vmWarn(500, $q . " " . $db->getErrorMsg());
	    	return '';
		}
		$this->getPaymentCurrency($paymentTable);

		$html = '<table class="adminlist table">' . "\n";
		$html .=$this->getHtmlHeaderBE();
		$html .= $this->getHtmlRowBE('EASYPAY_PAYMENT_NAME', $paymentTable->payment_name);
		$html .= '</table>' . "\n";
		return $html;
    }

	function getCosts (VirtueMartCart $cart, $method, $cart_prices) {

		if (preg_match ('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr ($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}

	protected function checkConditions($cart, $method, $cart_prices)
    {
		    return true;
    }

	//Отсылка уведомления продавцу после завершения оплаты   
    function plgVmOnPaymentResponseReceived(  &$html)
    {
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$vendorId = 0;
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))
		{
	    	return null;
		}
		if (!$this->selectedThisElement($method->payment_element))
		{
	    	return false;
		}
		$payment_data = JRequest::get('post');
		vmdebug('plgVmOnPaymentResponseReceived', $payment_data);
		$order_number = $payment_data['invoice'];
		$return_context = $payment_data['custom'];
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		$virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number);
		$payment_name = $this->renderPluginName($method);
		$html = "Оплата прошла успешно.";
	
		return true;
    }
     
   //Нажатиe на кнопку "<<Назад в магазин"     
    function plgVmOnUserPaymentCancel()
    {
		return null;
    }
	
	// Проверка уведомления    
    function plgVmOnPaymentNotification()
    {
		if (!class_exists('VirtueMartModelOrders'))
		{
	    	require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		}
		$easypay_data = JRequest::get('post');//Получение данных
		$order_mer_code = $easypay_data['order_mer_code'];

		$payment = $this->getDataByOrderId($order_mer_code);
		$method = $this->getVmPluginMethod($payment->virtuemart_paymentmethod_id);
		
		$sum = $easypay_data['sum'];
		$mer_no = $easypay_data['mer_no'];
		$card = $easypay_data['card'];
		$purch_date = $easypay_data['purch_date'];
		$web_key = $method->web_key;
		$notify_signature = $easypay_data['notify_signature'];
		
		$signature_checked = -1;
		if (isset($order_mer_code) && isset($sum) && isset($mer_no) && isset($card) && isset($purch_date)){
			$signature_checked = 0;
			$sign = md5 ($order_mer_code . $sum . $mer_no . $card . $purch_date . $web_key);
			if ($sign == $notify_signature){// Проверка электронной подписи
				$signature_checked = 1;
			}
		}
					
		if ($signature_checked == 1){
			if (!class_exists('CurrencyDisplay')) {
				require(JPATH_VM_ADMINISTRATOR . DS . 'helpers' . DS . 'currencydisplay.php');
			}
			$this->getPaymentCurrency($method);
			$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
			$order_model  = new VirtueMartModelOrders();
			$order_info   = $order_model->getOrder($order_mer_code);
			header("HTTP/1.0 200 OK");
			print $status = 'OK | the notice is processed'; //Все успешно
			//Изменение статуса
			$new_status = $method->status_success;	
			$modelOrder = VmModel::getModel('orders');
			$order = array();
			$order['order_status'] = $new_status;
			$order['customer_notified'] = 1;
			$order['comments']='easypay';
			$modelOrder->updateStatusForOneOrder($order_mer_code, $order, true);			
		}elseif ($signature_checked == 0){
			header("HTTP/1.0 400 Bad Request");
			print $status = 'FAILED | incorrect digital signature'; //Ошибка вычисления электронной подписи
		}else{
			header("HTTP/1.0 400 Bad Request");
			print $status = 'FAILED | the notice is not processed'; //Ошибка в параметрах
		}
		return true;
    }
    
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
		return $this->onStoreInstallPluginTable($jplugin_id);
    }
    
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart)
    {
		return $this->OnSelectCheck($cart);
    }
    
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
    }	
	
    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }
    
    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id)))
		{
	    	return null;
		}
		if (!$this->selectedThisElement($method->payment_element))
		{
	    	return false;
		}
	 	$this->getPaymentCurrency($method);

		$paymentCurrencyId = $method->payment_currency;
    }
    
    function logingActions($params)
    {
    	jimport('joomla.error.log');
    	$options = array(
    		'format' => "{DATE}\t{TIME}\t{ORDER}\t{ACTION}"
		);
    	$log = &JLog::getInstance('easypay_events.log.php', $options);
    	$log->addEntry(array('ORDER' => $params['ORDER'],'ACTION' => $params['ACTION']));
    }
    
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array())
    {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }
    
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }
    
    function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
		return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data)
    {
		return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
		return $this->setOnTablePluginParams($name, $id, $table);
    }

	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	
}
